/********************************************************************/

/* function prototypes */

void MDinit(word32 *MDbuf);
/*
 *  initializes MDbuffer to "magic constants"
 */

void compress(word32 *MDbuf, word32 *X);
/*
 *  the compression function.
 *  transforms MDbuf using message bytes X[0] through X[15]
 */

void MDfinish(word32 *MDbuf, byte *strptr, word32 lswlen, word32 mswlen);
/*
 *  puts bytes from strptr into X and pad out; appends length 
 *  and finally, compresses the last block(s)
 *  note: length in bits == 8 * (lswlen + 2^32 mswlen).
 *  note: there are (lswlen mod 64) bytes left in strptr.
 */

/*********************** end of file rmd160.h ***********************/

struct RMDctx
{
    word32 MDbuf[5];
    word32 X[16];
    int eptr;
	word32 lenHi, lenLo;
};

void RMDinit(struct RMDctx *ctx);
void RMDUpdate(struct RMDctx *ctx, byte const * buf, unsigned len);
void RMDFinal(byte *buf, struct RMDctx *ctx);

int RMDfile0_len(struct RMDctx *ctx, FILE * f, word32 longcount);
int RMDfile(struct RMDctx *ctx, char *filename);
void RMD_addbuffer(struct RMDctx *ctx, byte * buf, int buflen, byte digest[20]);
